import { ModalController } from '@ionic/angular';
import { AbstractVariable } from '@iotize/tap/data';
import { Observable, Subscription } from 'rxjs';
export interface ChartInputSingle {
    name: string | Date;
    value: number;
    extra: number;
}
export declare type ChartInputTable = {
    name: string | Date;
} & {
    [vals: number]: number;
};
export interface ChartInputMutli {
    name: string | Date;
    series: ChartInputSingle[];
}
export interface ChartInputStreamVar {
    stream: Observable<number | number[]>;
    label: string;
}
export declare class ChartDataModel {
    labels: string | string[] | undefined | Function;
    subList: Subscription[];
    currentData: ChartInputStreamVar | ChartInputStreamVar[];
    initLabel(indexOrArray: string | string[] | undefined | Function): void;
    initVariable(variableOrArray: AbstractVariable<number | number[]> | AbstractVariable<number | number[]>[] | undefined): ChartInputStreamVar[];
    /**
     * @param inputs data inputs
     * @param history to show data with time
     * @param valueCountLimit when history has true, this one define the limit of length
     */
    defineInputStreamSingle(inputs: ChartInputStreamVar | ChartInputStreamVar[], history: boolean, valueCountLimit: number): Observable<any>;
    defineMultiInputStream(inputs: ChartInputStreamVar[]): Observable<ChartInputMutli[]>;
    defineMultiInputStreamTable(inputs: ChartInputStreamVar[]): Observable<ChartInputTable[]>;
    defineInputStreamMulti(inputs: ChartInputStreamVar | ChartInputStreamVar[], history: boolean, valueCountLimit: number): Observable<ChartInputMutli[]>;
    defineInputStreamHistoryMultiLegend(inputs: ChartInputStreamVar[], valueCountLimit: number): Observable<ChartInputMutli[]>;
    labelConfig(index: number, labelBundle: string): string;
    digit(n: number): string;
    showDetail(event: any, mod: ModalController, component: any): Promise<void>;
    currentDate(): string | Date;
    destroyCurrentSub(): void;
}
